## wasix-libc 2024.07.08.1+ds

=== Makefile ===
# These variables are specifically meant to be overridable via the make
# command-line.
# ?= doesn't work for CC and AR because make has a default value for them.
ifeq ($(origin CC), default)
CC := clang
endif
NM ?= $(patsubst %clang,%llvm-nm,$(filter-out ccache sccache,$(CC)))
ifeq ($(origin AR), default)
AR = $(patsubst %clang,%llvm-ar,$(filter-out ccache sccache,$(CC)))
endif
EXTRA_CFLAGS ?= -O2 -DNDEBUG -ftls-model=local-exec -D_WASI_EMULATED_MMAN -D_WASI_EMULATED_PROCESS_CLOCKS
# The directory where we build the sysroot.
SYSROOT ?= $(CURDIR)/sysroot
# A directory to install to for "make install".
INSTALL_DIR ?= /usr/local
# single or posix; note that pthread support is still a work-in-progress.
THREAD_MODEL ?= posix
# dlmalloc or none
MALLOC_IMPL ?= dlmalloc
# yes or no
BUILD_LIBC_TOP_HALF ?= yes
# The directory where we will store intermediate artifacts.
OBJDIR ?= build/$(TARGET_TRIPLE)

# When the length is no larger than this threshold, we consider the
# overhead of bulk memory opcodes to outweigh the performance benefit,
# and fall back to the original musl implementation. See
# https://github.com/WebAssembly/wasi-libc/pull/263 for relevant
# discussion
BULK_MEMORY_THRESHOLD ?= 32

# Variables from this point on are not meant to be overridable via the
# make command-line.

# Set the target variables. Multiarch triples notably omit the vendor field,
# which happens to be what we do for the main target triple too.
#TARGET_ARCH = wasm32
TARGET_TRIPLE = $(TARGET_ARCH)-wasi
MULTIARCH_TRIPLE = $(TARGET_ARCH)-wasi

# These variables describe the locations of various files and directories in
# the source tree.
DLMALLOC_DIR = dlmalloc
DLMALLOC_SRC_DIR = $(DLMALLOC_DIR)/src
DLMALLOC_SOURCES = $(DLMALLOC_SRC_DIR)/dlmalloc.c
DLMALLOC_INC = $(DLMALLOC_DIR)/include
EMMALLOC_DIR = emmalloc
EMMALLOC_SOURCES = $(EMMALLOC_DIR)/emmalloc.c
LIBC_BOTTOM_HALF_DIR = libc-bottom-half
LIBC_BOTTOM_HALF_CLOUDLIBC_SRC = $(LIBC_BOTTOM_HALF_DIR)/cloudlibc/src
LIBC_BOTTOM_HALF_CLOUDLIBC_SRC_INC = $(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/include
LIBC_BOTTOM_HALF_HEADERS_PUBLIC = $(LIBC_BOTTOM_HALF_DIR)/headers/public
LIBC_BOTTOM_HALF_HEADERS_PRIVATE = $(LIBC_BOTTOM_HALF_DIR)/headers/private
LIBC_BOTTOM_HALF_SOURCES = $(LIBC_BOTTOM_HALF_DIR)/sources
LIBC_BOTTOM_HALF_ALL_SOURCES = \
    $(sort \
    $(shell find $(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC) -name \*.c) \
    $(shell find $(LIBC_BOTTOM_HALF_SOURCES) -name \*.c))

# FIXME(https://reviews.llvm.org/D85567) - due to a bug in LLD the weak
# references to a function defined in `chdir.c` only work if `chdir.c` is at the
# end of the archive, but once that LLD review lands and propagates into LLVM
# then we don't have to do this.
LIBC_BOTTOM_HALF_ALL_SOURCES := $(filter-out $(LIBC_BOTTOM_HALF_SOURCES)/chdir.c,$(LIBC_BOTTOM_HALF_ALL_SOURCES))
LIBC_BOTTOM_HALF_ALL_SOURCES := $(LIBC_BOTTOM_HALF_ALL_SOURCES) $(LIBC_BOTTOM_HALF_SOURCES)/chdir.c

LIBWASI_EMULATED_MMAN_SOURCES = \
    $(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/mman -name \*.c))
LIBWASI_EMULATED_PROCESS_CLOCKS_SOURCES = \
    $(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/clocks -name \*.c))
LIBWASI_EMULATED_GETPID_SOURCES = \
    $(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/getpid -name \*.c))
LIBWASI_EMULATED_SIGNAL_SOURCES = \
    $(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/signal -name \*.c))
LIBC_BOTTOM_HALF_CRT_SOURCES = $(wildcard $(LIBC_BOTTOM_HALF_DIR)/crt/*.c)
LIBC_TOP_HALF_DIR = libc-top-half
LIBC_TOP_HALF_MUSL_DIR = $(LIBC_TOP_HALF_DIR)/musl
LIBC_TOP_HALF_MUSL_SRC_DIR = $(LIBC_TOP_HALF_MUSL_DIR)/src
LIBC_TOP_HALF_MUSL_INC = $(LIBC_TOP_HALF_MUSL_DIR)/include
LIBC_TOP_HALF_MUSL_SOURCES = \
    $(addprefix $(LIBC_TOP_HALF_MUSL_SRC_DIR)/, \
        internal/syscall_ret.c \
        misc/a64l.c \
        misc/basename.c \
        misc/dirname.c \
        misc/ffs.c \
        misc/ffsl.c \
        misc/ffsll.c \
        misc/fmtmsg.c \
        misc/getdomainname.c \
        misc/gethostid.c \
        misc/getopt.c \
        misc/getopt_long.c \
        misc/getsubopt.c \
        misc/getrlimit.c \
        misc/setrlimit.c \
        misc/getrusage.c \
        misc/uname.c \
        misc/nftw.c \
	misc/realpath.c \
        misc/syslog.c \
        errno/strerror.c \
        \
        network/services.c \
        network/getaddrinfo.c \
        network/getnameinfo.c \
        network/gethostbyname.c \
        network/gethostbyname_r.c \
        network/gethostbyname2.c \
        network/gethostbyname2_r.c \
        network/getservbyname.c \
        network/getservbyname_r.c \
        network/gethostbyaddr.c \
        network/gethostbyaddr_r.c \
        network/lookup_ipliteral.c \
        network/lookup_name.c \
        network/lookup_serv.c \
        network/freeaddrinfo.c \
        network/resolvconf.c \
        \
        network/gai_strerror.c \
        network/getservbyport.c \
        network/h_errno.c \
        network/hstrerror.c \
        network/htonl.c \
        network/htons.c \
        network/ntohl.c \
        network/ntohs.c \
        network/inet_ntop.c \
	    network/inet_ntoa.c \
        network/inet_pton.c \
        network/inet_aton.c \
        network/in6addr_any.c \
        network/in6addr_loopback.c \
        network/proto.c \
        fenv/fenv.c \
        fenv/fesetround.c \
        fenv/feupdateenv.c \
        fenv/fesetexceptflag.c \
        fenv/fegetexceptflag.c \
        fenv/feholdexcept.c \
        exit/exit.c \
        exit/atexit.c \
        exit/assert.c \
        exit/quick_exit.c \
        exit/at_quick_exit.c \
        time/strftime.c \
        time/asctime.c \
        time/asctime_r.c \
        time/ctime.c \
        time/ctime_r.c \
        time/wcsftime.c \
        time/strptime.c \
        time/difftime.c \
        time/timegm.c \
        time/ftime.c \
        time/times.c \
        time/gmtime.c \
        time/gmtime_r.c \
        time/timespec_get.c \
        time/getdate.c \
        time/localtime.c \
        time/localtime_r.c \
        time/mktime.c \
        time/gettimeofday.c \
        time/__tm_to_secs.c \
        time/__month_to_secs.c \
        time/__secs_to_tm.c \
        time/__year_to_secs.c \
        time/__tz.c \
        fcntl/creat.c \
        dirent/alphasort.c \
        dirent/versionsort.c \
        env/__stack_chk_fail.c \
        env/clearenv.c \
        env/getenv.c \
        env/putenv.c \
        env/setenv.c \
        env/unsetenv.c \
        unistd/posix_close.c \
        unistd/tcgetpgrp.c \
        unistd/tcsetpgrp.c \
        unistd/getpgid.c \
        unistd/getpgrp.c \
        unistd/setpgid.c \
        unistd/setpgrp.c \
        unistd/getsid.c \
        unistd/setsid.c \
        unistd/gethostname.c \
        unistd/alarm.c \
        unistd/ualarm.c \
        unistd/ttyname.c \
        unistd/ttyname_r.c \
        linux/wait3.c \
        linux/wait4.c \
        linux/epoll.c \
        linux/eventfd.c \
        linux/setgroups.c \
        stat/futimesat.c \
        legacy/getpagesize.c \
        thread/thrd_sleep.c \
    ) \
    $(filter-out %/procfdname.c %/syscall.c %/syscall_ret.c %/vdso.c %/version.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/internal/*.c)) \
    $(filter-out %/rename.c \
                 %/tmpnam.c %/tempnam.c \
                 %/remove.c \
                 %/gets.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/*.c)) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/*.c) \
    $(filter-out %/bind_textdomain_codeset.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/locale/*.c)) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/setjmp/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/thread/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/signal/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/process/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/env/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/exit/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/search/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/multibyte/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/regex/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/prng/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/conf/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/passwd/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/ctype/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/termios/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/temp/*.c) \
    $(filter-out %/__signbit.c %/__signbitf.c %/__signbitl.c \
                 %/__fpclassify.c %/__fpclassifyf.c %/__fpclassifyl.c \
                 %/ceilf.c %/ceil.c \
                 %/floorf.c %/floor.c \
                 %/truncf.c %/trunc.c \
                 %/rintf.c %/rint.c \
                 %/nearbyintf.c %/nearbyint.c \
                 %/sqrtf.c %/sqrt.c \
                 %/fabsf.c %/fabs.c \
                 %/copysignf.c %/copysign.c \
                 %/fminf.c %/fmaxf.c \
                 %/fmin.c %/fmax.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/math/*.c)) \
    $(filter-out %/crealf.c %/creal.c %creall.c \
                 %/cimagf.c %/cimag.c %cimagl.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/complex/*.c)) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/crypt/*.c)

ifeq ($(THREAD_MODEL), posix)
LIBC_TOP_HALF_MUSL_SOURCES += \
    $(addprefix $(LIBC_TOP_HALF_MUSL_SRC_DIR)/, \
        env/__init_tls.c \
        stdio/__lockfile.c \
        stdio/flockfile.c \
        stdio/ftrylockfile.c \
        stdio/funlockfile.c \
        thread/__lock.c \
        thread/__wait.c \
        thread/__timedwait.c \
        thread/default_attr.c \
        thread/pthread_attr_destroy.c \
        thread/pthread_attr_get.c \
        thread/pthread_attr_init.c \
        thread/pthread_attr_setstack.c \
        thread/pthread_attr_setdetachstate.c \
        thread/pthread_attr_setstacksize.c \
        thread/pthread_barrier_destroy.c \
        thread/pthread_barrier_init.c \
        thread/pthread_barrier_wait.c \
        thread/pthread_cleanup_push.c \
        thread/pthread_cond_broadcast.c \
        thread/pthread_cond_destroy.c \
        thread/pthread_cond_init.c \
        thread/pthread_cond_signal.c \
        thread/pthread_cond_timedwait.c \
        thread/pthread_cond_wait.c \
        thread/pthread_condattr_destroy.c \
        thread/pthread_condattr_init.c \
        thread/pthread_condattr_setclock.c \
        thread/pthread_condattr_setpshared.c \
        thread/pthread_create.c \
        thread/pthread_detach.c \
        thread/pthread_equal.c \
        thread/pthread_getspecific.c \
        thread/pthread_join.c \
        thread/pthread_key_create.c \
        thread/pthread_mutex_consistent.c \
        thread/pthread_mutex_destroy.c \
        thread/pthread_mutex_init.c \
        thread/pthread_mutex_getprioceiling.c \
        thread/pthread_mutex_lock.c \
        thread/pthread_mutex_timedlock.c \
        thread/pthread_mutex_trylock.c \
        thread/pthread_mutex_unlock.c \
        thread/pthread_mutexattr_destroy.c \
        thread/pthread_mutexattr_init.c \
        thread/pthread_mutexattr_setprotocol.c \
        thread/pthread_mutexattr_setpshared.c \
        thread/pthread_mutexattr_setrobust.c \
        thread/pthread_mutexattr_settype.c \
        thread/pthread_once.c \
        thread/pthread_rwlock_destroy.c \
        thread/pthread_rwlock_init.c \
        thread/pthread_rwlock_rdlock.c \
        thread/pthread_rwlock_timedrdlock.c \
        thread/pthread_rwlock_timedwrlock.c \
        thread/pthread_rwlock_tryrdlock.c \
        thread/pthread_rwlock_trywrlock.c \
        thread/pthread_rwlock_unlock.c \
        thread/pthread_rwlock_wrlock.c \
        thread/pthread_rwlockattr_destroy.c \
        thread/pthread_rwlockattr_init.c \
        thread/pthread_rwlockattr_setpshared.c \
        thread/pthread_setcancelstate.c \
        thread/pthread_setspecific.c \

=== debian/changelog ===
wasix-libc (2024.07.08.1+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1056052)

 -- Fukui Daichi <a.dog.will.talk@akane.waseda.jp>  Sun, 25 Aug 2024 06:48:36 +0000

=== debian/control ===
Source: wasix-libc
Section: devel
Priority: optional
Maintainer: Fukui Daichi <a.dog.will.talk@akane.waseda.jp>
Build-Depends: debhelper-compat (= 13), clang-16, llvm-16, libclang-rt-16-dev-wasm32
Standards-Version: 4.7.0
Homepage: https://github.com/wasix-org/wasix-libc
Rules-Requires-Root: no

Package: wasix-libc
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: wasi-libc
Description: wasix libc implementation for WebAssembly
 This fork of wasi-libc extends libc with the missing functionality needed to
 build complete and useful applications, in particular it incorporates these
 additional extensions:
  - full support for efficient multithreading including joins, signals
    and `getpid`
  - `pthreads` support (now extended from the WASI threads spec)
  - full support for sockets (`socket`, `bind`, `connect`, `resolve`)
      - IPv4, IPv6
      - UDP, TCP
      - Multicast, Anycast
      - RAW sockets
  - current directory support (`chdir`) integrated with the runtime
  - `setjmp` / `longjmp` support (used extensively in `libc` ) via `asyncify`
  - process forking (`fork` and `vfork` )
  - subprocess spawning and waiting (`exec` , `wait` )
  - TTY support
  - asynchronous polling of sockets and files
  - pipe and event support (`pipe`, `event` )
  - DNS resolution support (`resolve` )

=== debian/rules ===
#!/usr/bin/make -f

export NM = llvm-nm-16
export AR = llvm-ar-16
export CC = clang-16
export TARGET_OS = wasix
export TARGET_ARCH = wasm32

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- finish

override_dh_installexamples:
	dh_installexamples -Xgitignore


override_dh_auto_install:
	dh_auto_install -- INSTALL_DIR=$(CURDIR)/debian/tmp/usr
	find $(CURDIR)/debian/tmp/usr -type d -empty -delete

## wasix-libc 2025.07.07.1+ds

=== Makefile ===
--- 
+++ 
@@ -21,6 +21,8 @@
 BUILD_LIBC_TOP_HALF ?= yes
 # The directory where we will store intermediate artifacts.
 OBJDIR ?= build/$(TARGET_TRIPLE)
+# Whether to compile with PIC (needed for shared libs and dynamic linking)
+PIC ?= no
 
 # When the length is no larger than this threshold, we consider the
 # overhead of bulk memory opcodes to outweigh the performance benefit,
@@ -92,6 +94,7 @@
         misc/getopt.c \
         misc/getopt_long.c \
         misc/getsubopt.c \
+        misc/initgroups.c \
         misc/getrlimit.c \
         misc/setrlimit.c \
         misc/getrusage.c \
@@ -196,6 +199,11 @@
         linux/epoll.c \
         linux/eventfd.c \
         linux/setgroups.c \
+        ldso/dlclose.c \
+        ldso/dlerror.c \
+        ldso/dlinfo.c \
+        ldso/dlopen.c \
+        ldso/dlsym.c \
         stat/futimesat.c \
         legacy/getpagesize.c \
         thread/thrd_sleep.c \
@@ -306,8 +314,3 @@
         thread/pthread_rwlock_trywrlock.c \
         thread/pthread_rwlock_unlock.c \
         thread/pthread_rwlock_wrlock.c \
-        thread/pthread_rwlockattr_destroy.c \
-        thread/pthread_rwlockattr_init.c \
-        thread/pthread_rwlockattr_setpshared.c \
-        thread/pthread_setcancelstate.c \
-        thread/pthread_setspecific.c \

=== examples/Makefile ===
CC ?= "clang"
SYSROOT ?= "../sysroot32"
LLD_PATH=/prog/rust/build/x86_64-unknown-linux-gnu/lld/bin

CFLAGS = --target=wasm32-wasmer-wasi \
         -O2 \
         --sysroot ${SYSROOT} \
         -matomics \
         -mbulk-memory \
         -mmutable-globals \
         -pthread \
         -mthread-model posix \
         -ftls-model=local-exec \
         -fno-trapping-math \
         -D_WASI_EMULATED_MMAN \
         -D_WASI_EMULATED_SIGNAL \
		 -D_WASI_EMULATED_PROCESS_CLOCKS \
         -Wall \
         -Wextra \
         -Werror \
         -Wno-null-pointer-arithmetic \
         -Wno-unused-parameter \
         -Wno-sign-compare \
         -Wno-unused-variable \
         -Wno-unused-function \
         -Wno-ignored-attributes \
         -Wno-missing-braces \
         -Wno-ignored-pragmas \
         -Wno-unused-but-set-variable \
         -Wno-unknown-warning-option \
         -Wno-parentheses \
         -Wno-shift-op-parentheses \
         -Wno-bitwise-op-parentheses \
         -Wno-logical-op-parentheses \
         -Wno-string-plus-int \
         -Wno-dangling-else \
         -Wno-unknown-pragmas \
         -MD \
         -MP

CLFLAGS = -Wl,--shared-memory \
          -Wl,--max-memory=4294967296 \
          -Wl,--import-memory \
          -Wl,--export-dynamic \
		  -Wl,--export=__heap_base \
          -Wl,--export=__stack_pointer \
          -Wl,--export=__data_end \
          -Wl,--export=__wasm_init_tls \
          -Wl,--export=__wasm_signal \
          -Wl,--export=__tls_size \
          -Wl,--export=__tls_align \
          -Wl,--export=__tls_base

SRC=$(wildcard *.c)

export PATH := $(LLD_PATH):$(PATH)

all: longjmp file-copy signal fork vfork fork-longjmp execve spawn pipe epoll getrandom readdir_tree
	cp -f ../dist/wasix/longjmp.wasm ../../wasmer/tests/integration/cli/tests/wasm/example-longjmp.wasm
	cp -f ../dist/wasix/fork.wasm ../../wasmer/tests/integration/cli/tests/wasm/example-fork.wasm
	cp -f ../dist/wasix/fork.wasm ../../packages/fork-test/test.wasm
	cp -f ../dist/wasix/fork-longjmp.wasm ../../wasmer/tests/integration/cli/tests/wasm/example-fork-longjmp.wasm
	cp -f ../dist/wasix/vfork.wasm ../../wasmer/tests/integration/cli/tests/wasm/example-vfork.wasm
	cp -f ../dist/wasix/signal.wasm ../../wasmer/tests/integration/cli/tests/wasm/example-signal.wasm
	cp -f ../dist/wasix/execve.wasm ../../wasmer/tests/integration/cli/tests/wasm/example-execve.wasm
	cp -f ../dist/wasix/spawn.wasm ../../wasmer/tests/integration/cli/tests/wasm/example-spawn.wasm
	cp -f ../dist/wasix/pipe.wasm ../../wasmer/tests/integration/cli/tests/wasm/example-pipe.wasm
	cp -f ../dist/wasix/epoll.wasm ../../wasmer/tests/integration/cli/tests/wasm/example-epoll.wasm
	cp -f ../dist/wasix/file-copy.wasm ../../wasmer/tests/integration/cli/tests/wasm/example-file-copy.wasm

%: %.c
	mkdir -p ../dist/host
	${CC} $(CFLAGS) $@.c -o ../dist/host/$@
	mkdir -p ../dist/wasix
	${CC} $(CFLAGS) $(CLFLAGS) \
              $@.c \
              -o ../dist/wasix/$@.rustc.wasm
	wasm-opt -O2 --asyncify ../dist/wasix/$@.rustc.wasm -o ../dist/wasix/$@.wasm

clean:
	rm -f *.o
	rm -f *.s
	rm -f *.ll
	rm -f *~
	rm -f ../dist/host/*
	rm -f ../dist/wasix/*

=== test/Makefile ===
# Build the `libc-test` tests as Wasm programs and run them with the selected
# engine. Contributors beware! This Makefile follows the style of the
# `libc-test` Makefile and uses some more exotic features of `make`.
#
# The top-level `test` target is composed of a chain of several phony
# sub-targets:
# - `download`: retrieve the `libc-test` source from a Git `$(MIRROR)`
# - `build`: construct Wasm modules for a subset of the `libc-test` tests
# - `run`: execute the benchmarks with a Wasm `$(ENGINE)` of choice (e.g.,
#   Wasmtime)

test: run

# Unlike the `libc-test` directory, we will output all artifacts to the `build`
# directory (keeping with the `wasi-libc` conventions).
OBJDIR ?= $(CURDIR)/build
DOWNDIR ?= $(CURDIR)/download

##### DOWNLOAD #################################################################

LIBC_TEST_URL ?= https://github.com/bytecodealliance/libc-test
LIBC_TEST = $(DOWNDIR)/libc-test
LIBRT_URL ?= https://github.com/WebAssembly/wasi-sdk/releases/download/wasi-sdk-16/libclang_rt.builtins-wasm32-wasi-16.0.tar.gz
LIBRT = $(DOWNDIR)/lib/wasi/libclang_rt.builtins-wasm32.a
WASMTIME_URL ?= https://github.com/bytecodealliance/wasmtime/releases/download/v3.0.0/wasmtime-v3.0.0-x86_64-linux.tar.xz
WASMTIME = $(DOWNDIR)/$(shell basename $(WASMTIME_URL) .tar.xz)/wasmtime

download: $(LIBC_TEST) $(LIBRT) $(WASMTIME)

$(DOWNDIR):
	mkdir -p download

$(LIBC_TEST): | $(DOWNDIR)
	git clone --depth 1 $(LIBC_TEST_URL) $@

# TODO install target to place into...
$(LIBRT): | $(DOWNDIR)
	wget --no-clobber --directory-prefix=$(DOWNDIR) $(LIBRT_URL)
	tar --extract --file=$(DOWNDIR)/$(shell basename $(LIBRT_URL)) --directory=$(DOWNDIR)/	

$(WASMTIME): | $(DOWNDIR)
	wget --no-clobber --directory-prefix=$(DOWNDIR) $(WASMTIME_URL)
	tar --extract --file=$(DOWNDIR)/$(shell basename $(WASMTIME_URL)) --directory=$(DOWNDIR)/

clean::
	rm -rf download

##### BUILD ####################################################################

# For now, we list out the tests that we can currently build and run. This is
# heavily focused on the functional tests; in the future it would be good to
# fill out the missing tests and also include some `src/api` and `src/math`
# tests (TODO).
TESTS := \
	$(LIBC_TEST)/src/functional/argv.c \
	$(LIBC_TEST)/src/functional/basename.c \
	$(LIBC_TEST)/src/functional/clocale_mbfuncs.c \
	$(LIBC_TEST)/src/functional/clock_gettime.c \
	$(LIBC_TEST)/src/functional/crypt.c \
	$(LIBC_TEST)/src/functional/dirname.c \
	$(LIBC_TEST)/src/functional/env.c \
	$(LIBC_TEST)/src/functional/fnmatch.c \
	$(LIBC_TEST)/src/functional/iconv_open.c \
	$(LIBC_TEST)/src/functional/mbc.c \
	$(LIBC_TEST)/src/functional/memstream.c \
	$(LIBC_TEST)/src/functional/qsort.c \
	$(LIBC_TEST)/src/functional/random.c \
	$(LIBC_TEST)/src/functional/search_hsearch.c \
	$(LIBC_TEST)/src/functional/search_insque.c \
	$(LIBC_TEST)/src/functional/search_lsearch.c \
	$(LIBC_TEST)/src/functional/search_tsearch.c \
	$(LIBC_TEST)/src/functional/snprintf.c \
	$(LIBC_TEST)/src/functional/sscanf.c \
	$(LIBC_TEST)/src/functional/strftime.c \
	$(LIBC_TEST)/src/functional/string.c \
	$(LIBC_TEST)/src/functional/string_memcpy.c \
	$(LIBC_TEST)/src/functional/string_memmem.c \
	$(LIBC_TEST)/src/functional/string_memset.c \
	$(LIBC_TEST)/src/functional/string_strchr.c \
	$(LIBC_TEST)/src/functional/string_strcspn.c \
	$(LIBC_TEST)/src/functional/string_strstr.c \
	$(LIBC_TEST)/src/functional/strtod.c \
	$(LIBC_TEST)/src/functional/strtod_long.c \
	$(LIBC_TEST)/src/functional/strtod_simple.c \
	$(LIBC_TEST)/src/functional/strtof.c \
	$(LIBC_TEST)/src/functional/strtol.c \
	$(LIBC_TEST)/src/functional/swprintf.c \
	$(LIBC_TEST)/src/functional/tgmath.c \
	$(LIBC_TEST)/src/functional/udiv.c \
	$(LIBC_TEST)/src/functional/wcsstr.c \
	$(LIBC_TEST)/src/functional/wcstol.c

# Part of the problem including more tests is that the `libc-test`
# infrastructure code is not all Wasm-compilable. As we include more tests
# above, this list will also likely need to grow.
COMMON_TEST_INFRA = \
	$(LIBC_TEST)/src/common/path.c \
	$(LIBC_TEST)/src/common/print.c \
	$(LIBC_TEST)/src/common/rand.c \
	$(LIBC_TEST)/src/common/utf8.c

# Create various lists containing the various artifacts to be built: mainly,
# $(WASM_OBJS) are compiled in the $(OBJDIRS) and then linked together to form
# the $(WASMS) tests.
NAMES := $(TESTS:$(LIBC_TEST)/src/%.c=%)
WASMS := $(TESTS:$(LIBC_TEST)/src/%.c=$(OBJDIR)/%.wasm)
WASM_OBJS := $(TESTS:$(LIBC_TEST)/src/%.c=$(OBJDIR)/%.wasm.o)
INFRA_WASM_OBJS := $(COMMON_TEST_INFRA:$(LIBC_TEST)/src/%.c=$(OBJDIR)/%.wasm.o)
WASM_OBJS += $(INFRA_WASM_OBJS)
DIRS := $(patsubst $(OBJDIR)/%/,%,$(sort $(dir $(WASM_OBJS))))
OBJDIRS := $(DIRS:%=$(OBJDIR)/%)

# Allow $(CC) to be set from the command line; ?= doesn't work for CC because
# make has a default value for it.
ifeq ($(origin CC), default)
CC := clang
endif
LDFLAGS ?=
CFLAGS ?= --target=wasm32-wasi --sysroot=../sysroot
# Always include the `libc-test` infrastructure headers.
CFLAGS += -I$(LIBC_TEST)/src/common

# Compile each selected test using Clang. Note that failures here are likely
# due to a missing `libclang_rt.builtins-wasm32.a` in the Clang lib directory.
# This location is system-dependent, but could be fixed by something like:
#  $ sudo mkdir /usr/lib64/clang/14.0.5/lib/wasi
#  $ sudo cp download/lib/wasi/libclang_rt.builtins-wasm32.a /usr/lib64/clang/14.0.5/lib/wasi/
build: download $(WASMS)

$(WASMS): | $(OBJDIRS)
$(OBJDIR)/%.wasm: $(OBJDIR)/%.wasm.o $(INFRA_WASM_OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ 

$(WASM_OBJS): $(LIBC_TEST)/src/common/test.h | $(OBJDIRS)
$(OBJDIR)/%.wasm.o: $(LIBC_TEST)/src/%.c
	$(CC) $(CFLAGS) -c -o $@ $< 

$(OBJDIRS):
	mkdir -p $@

clean::
	rm -rf $(OBJDIR)

##### RUN ######################################################################

ENGINE ?= $(WASMTIME) run
ERRS:=$(WASMS:%.wasm=%.wasm.err)

# Use the provided Wasm engine to execute each test, emitting its output into
# a `.err` file.
run: build $(ERRS)
	@echo "Tests passed"

$(ERRS): | $(OBJDIRS)

%.wasm.err: %.wasm
	$(ENGINE) $< >$@

clean::
	rm -rf $(OBJDIR)/*/*.err

##### MISC #####################################################################

# Note: the `clean` target has been built up by all of the previous sections.

debug:
	@echo NAMES $(NAMES)
	@echo TESTS $(TESTS)
	@echo WASMS $(WASMS)
	@echo WASM_OBJS $(WASM_OBJS)
	@echo ERRS $(ERRS)
	@echo DIRS $(DIRS)
	@echo OBJDIRS $(OBJDIRS)

.PHONY: test download build run clean

=== test/wasix/c_pthreads/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.0)
project (basic_executable)

add_executable(main main.c)

=== test/wasix/cpp_atomic/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.0)
project (basic_executable)

add_executable(main main.cpp)

=== debian/changelog ===
wasix-libc (2025.07.07.1+ds-1) unstable; urgency=medium

  [ Fukui Daichi ]
  * d/rules: Remove obsoleted get-orig-source target
  * New upstream version 2025.07.07.1
  * d/patches: Fix imcompatible cast
  * d/patches: Remove undefined symbols
  * d/control: Update to remove versioned clang/llvm (Closes: #1103497)
  * d/rules: Remove versioned clang/llvm commands

  [ Dmitry Smirnov ]
  * watch: rewrite for Github API.

 -- Fukui Daichi <a.dog.will.talk@akane.waseda.jp>  Thu, 28 Aug 2025 23:17:25 +0900

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Fukui Daichi <a.dog.will.talk@akane.waseda.jp>
-Build-Depends: debhelper-compat (= 13), clang-16, llvm-16, libclang-rt-16-dev-wasm32
+Build-Depends: debhelper-compat (= 13), clang, llvm, libclang-rt-dev-wasm32
 Standards-Version: 4.7.0
 Homepage: https://github.com/wasix-org/wasix-libc
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,8 @@
 #!/usr/bin/make -f
 
-export NM = llvm-nm-16
-export AR = llvm-ar-16
-export CC = clang-16
+export NM = llvm-nm
+export AR = llvm-ar
+export CC = clang
 export TARGET_OS = wasix
 export TARGET_ARCH = wasm32

=== debian/watch ===
# https://salsa.debian.org/snippets/95
# https://wiki.debian.org/debian/watch
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
compression=xz,\
repack,repacksuffix=+ds,\
dversionmangle=s{[+~](dfsg|ds)\d*}{},\
uversionmangle=s{[\-]}{.}g,\
filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%,\
searchmode=plain,\
" https://api.github.com/repos/wasix-org/wasix-libc/releases?per_page=99 \
  https://api.github.com/repos/[^/]+/[^/]+/tarball/v?([\d.\-]+) debian uupdate

## wasix-libc 2025.12.24.1%2Bds

=== debian/changelog ===
wasix-libc (2025.12.24.1+ds-1) unstable; urgency=medium

  * New upstream version 2025.12.24.1 (Closes: #1123481)
  * d/patches: Drop 0003-remove-undefined-symbols.patch as no longer needed
    with the latest version of wasix-libc
  * d/patches: Drop 0002-fix-imcompatible-cast.patch as no longer needed
    with the latest version of clang
  * d/control: Bump Standards-Version to 4.7.3
  * d/control: Drop libclang-rt-dev-wasm32 from Build-Depends
    This package is actually not used at build time.

 -- Fukui Daichi <a.dog.will.talk@akane.waseda.jp>  Sat, 03 Jan 2026 13:53:30 +0000

## wasix-libc 2025.12.24.1+ds

=== Makefile ===
--- 
+++ 
@@ -23,6 +23,11 @@
 OBJDIR ?= build/$(TARGET_TRIPLE)
 # Whether to compile with PIC (needed for shared libs and dynamic linking)
 PIC ?= no
+# Whether to verify the build symbols against the expected symbol list.
+# Disabling this is useful for development, where differences in the
+# exact version of clang can cause some symbols (especially macros) to
+# be added or removed.
+CHECK_SYMBOLS ?= yes
 
 # When the length is no larger than this threshold, we consider the
 # overhead of bulk memory opcodes to outweigh the performance benefit,
@@ -66,8 +71,9 @@
 LIBC_BOTTOM_HALF_ALL_SOURCES := $(filter-out $(LIBC_BOTTOM_HALF_SOURCES)/chdir.c,$(LIBC_BOTTOM_HALF_ALL_SOURCES))
 LIBC_BOTTOM_HALF_ALL_SOURCES := $(LIBC_BOTTOM_HALF_ALL_SOURCES) $(LIBC_BOTTOM_HALF_SOURCES)/chdir.c
 
+# shm_open.c is included in the main libc.
 LIBWASI_EMULATED_MMAN_SOURCES = \
-    $(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/mman -name \*.c))
+    $(filter-out %/shm_open.c,$(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/mman -name \*.c)))
 LIBWASI_EMULATED_PROCESS_CLOCKS_SOURCES = \
     $(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/clocks -name \*.c))
 LIBWASI_EMULATED_GETPID_SOURCES = \
@@ -102,6 +108,7 @@
         misc/nftw.c \
 	misc/realpath.c \
         misc/syslog.c \
+        mman/shm_open.c \
         errno/strerror.c \
         \
         network/services.c \
@@ -152,6 +159,7 @@
         time/asctime_r.c \
         time/ctime.c \
         time/ctime_r.c \
+        time/clock.c \
         time/wcsftime.c \
         time/strptime.c \
         time/difftime.c \
@@ -194,6 +202,10 @@
         unistd/ualarm.c \
         unistd/ttyname.c \
         unistd/ttyname_r.c \
+        unistd/chown.c \
+        unistd/fchown.c \
+        unistd/fchownat.c \
+        unistd/lchown.c \
         linux/wait3.c \
         linux/wait4.c \
         linux/epoll.c \
@@ -206,7 +218,14 @@
         ldso/dlsym.c \
         stat/futimesat.c \
         legacy/getpagesize.c \
+        legacy/getpass.c \
         thread/thrd_sleep.c \
+        wasix/call_dynamic.c \
+        wasix/closure_allocate.c \
+        wasix/closure_free.c \
+        wasix/closure_prepare.c \
+        wasix/reflection.c \
+        wasix/context.c \
     ) \
     $(filter-out %/procfdname.c %/syscall.c %/syscall_ret.c %/vdso.c %/version.c, \
                  $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/internal/*.c)) \
@@ -298,19 +317,3 @@
         thread/pthread_mutex_timedlock.c \
         thread/pthread_mutex_trylock.c \
         thread/pthread_mutex_unlock.c \
-        thread/pthread_mutexattr_destroy.c \
-        thread/pthread_mutexattr_init.c \
-        thread/pthread_mutexattr_setprotocol.c \
-        thread/pthread_mutexattr_setpshared.c \
-        thread/pthread_mutexattr_setrobust.c \
-        thread/pthread_mutexattr_settype.c \
-        thread/pthread_once.c \
-        thread/pthread_rwlock_destroy.c \
-        thread/pthread_rwlock_init.c \
-        thread/pthread_rwlock_rdlock.c \
-        thread/pthread_rwlock_timedrdlock.c \
-        thread/pthread_rwlock_timedwrlock.c \
-        thread/pthread_rwlock_tryrdlock.c \
-        thread/pthread_rwlock_trywrlock.c \
-        thread/pthread_rwlock_unlock.c \
-        thread/pthread_rwlock_wrlock.c \

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Fukui Daichi <a.dog.will.talk@akane.waseda.jp>
 Build-Depends: debhelper-compat (= 13), clang, llvm, libclang-rt-dev-wasm32
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://github.com/wasix-org/wasix-libc
 Rules-Requires-Root: no
